﻿<%@ Page Language="VB" AutoEventWireup="false" CodeFile="Default.aspx.vb" Inherits="_Default" %>

<%@ Register assembly="AjaxControlToolkit" namespace="AjaxControlToolkit" tagprefix="cc1" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>Formatting the GridView During Edits</title>
    <link href="Style.css" rel="stylesheet" type="text/css" />
    
      
    <style type="text/css">
        .style1
        {
            color: #FFFFFF;
        }
        .style2
        {
            text-align: center;
        }
    </style>
    
      
</head>
<body>
    <form id="form1" runat="server">
    <div class="style2" >
        <span class="style1">Grid Formatting&nbsp;
        Demo</span><br class="style1" />
        <span class="style1">Version 1.5</span><br class="style1" />
        <span class="style1">AJAX-Enabled Grid, Confirm Delete, the Accordian Control And More!</span></div>
    <asp:ScriptManager ID="ScriptManager1" runat="server">
    </asp:ScriptManager>
   
    <div id="maincontent">
        <asp:UpdatePanel ID="UpdatePanel1" runat="server">
        <ContentTemplate>
        
        <asp:SqlDataSource ID="SqlDataSource1" runat="server" 
            ConnectionString="<%$ ConnectionStrings:customers-05ConnectionString %>" 
            DeleteCommand="DELETE FROM [customers] WHERE [CustID] = @CustID" 
            InsertCommand="INSERT INTO [customers] ([Name], [Address], [City], [State]) VALUES (@Name, @Address, @City, @State)" 
            SelectCommand="SELECT [CustID], [Name], [Address], [City], [State] FROM [customers] ORDER BY [CustID]" 
            UpdateCommand="UPDATE [customers] SET [Name] = @Name, [Address] = @Address, [City] = @City, [State] = @State WHERE [CustID] = @CustID">
            <DeleteParameters>
                <asp:Parameter Name="CustID" Type="Int32" />
            </DeleteParameters>
            <UpdateParameters>
                <asp:Parameter Name="Name" Type="String" />
                <asp:Parameter Name="Address" Type="String" />
                <asp:Parameter Name="City" Type="String" />
                <asp:Parameter Name="State" Type="String" />
                <asp:Parameter Name="CustID" Type="Int32" />
            </UpdateParameters>
            <InsertParameters>
                <asp:Parameter Name="Name" Type="String" />
                <asp:Parameter Name="Address" Type="String" />
                <asp:Parameter Name="City" Type="String" />
                <asp:Parameter Name="State" Type="String" />
            </InsertParameters>
        </asp:SqlDataSource>
    
            <div class="header">
                <span class="header">Welcome to Mr. GridView. This demo shows you how to setup 
                the template that controls the size of the textboxes when the grid is being 
                edited. I also added a Required Field Validator for the State field. Be sure to 
                look at the ReadMe First file.</span><br />
            </div>
    
        <table class="tables">
            <tr>
                <td>
                   
                    <br />
                    <b>
                    <asp:GridView ID="GridView1"  CssClass="gridview" runat="server" AllowSorting="True" 
                        AutoGenerateColumns="False" BackColor="#DEBA84" BorderColor="#DEBA84" 
                        BorderStyle="None" BorderWidth="1px" 
                        Caption="How To Change Column Width While Editing" CaptionAlign="Top" 
                        CellPadding="3" CellSpacing="2" DataKeyNames="CustID" 
                        DataSourceID="SqlDataSource1" Font-Bold="False" Font-Size="10pt" >
                        <RowStyle BackColor="#FFF7E7" ForeColor="#8C4510" HorizontalAlign="Right" />
                        <Columns>
                            <asp:TemplateField ShowHeader="False">
                                <EditItemTemplate>
                                    <asp:LinkButton ID="LinkButton1" runat="server" CausesValidation="True" 
                                        CommandName="Update" Text="Update"></asp:LinkButton>
                                    &nbsp;<asp:LinkButton ID="LinkButton2" runat="server" CausesValidation="False" 
                                        CommandName="Cancel" Text="Cancel"></asp:LinkButton>
                                </EditItemTemplate>
                                <ItemTemplate>
                                    <asp:LinkButton ID="LinkButton1" runat="server" CausesValidation="False" 
                                        CommandName="Edit" Text="Edit"></asp:LinkButton>
                                    &nbsp;<asp:LinkButton ID="LinkButton2" runat="server" CausesValidation="False" 
                                        CommandName="Delete" 
                                        onclientclick="return confirm(&quot;Are you sure you want to delete?&quot;);" 
                                        Text="Delete"></asp:LinkButton>
                                </ItemTemplate>
                            </asp:TemplateField>
                            <asp:BoundField DataField="CustID" HeaderText="CustID" InsertVisible="False" 
                                ReadOnly="True" SortExpression="CustID" />
                            <asp:TemplateField HeaderText="Name" SortExpression="Name">
                                <EditItemTemplate>
                                    <asp:TextBox ID="txtEditName" runat="server" Columns="15" MaxLength="15" 
                                        Text='<%# Bind("Name", "{0}") %>'></asp:TextBox>
                                </EditItemTemplate>
                                <ItemTemplate>
                                    <asp:Label ID="Label2" runat="server" Text='<%# Bind("Name") %>'></asp:Label>
                                </ItemTemplate>
                            </asp:TemplateField>
                            <asp:TemplateField HeaderText="Address" SortExpression="Address">
                                <EditItemTemplate>
                                    <asp:TextBox ID="TextBox3" runat="server" Columns="15" MaxLength="15" 
                                        Text='<%# Bind("Address") %>'></asp:TextBox>
                                </EditItemTemplate>
                                <ItemTemplate>
                                    <asp:Label ID="Label3" runat="server" Text='<%# Bind("Address") %>'></asp:Label>
                                </ItemTemplate>
                            </asp:TemplateField>
                            <asp:TemplateField HeaderText="City" SortExpression="City">
                                <EditItemTemplate>
                                    <asp:TextBox ID="TextBox4" runat="server" Columns="15" MaxLength="15" 
                                        Text='<%# Bind("City") %>'></asp:TextBox>
                                </EditItemTemplate>
                                <ItemTemplate>
                                    <asp:Label ID="Label4" runat="server" Text='<%# Bind("City") %>'></asp:Label>
                                </ItemTemplate>
                            </asp:TemplateField>
                            <asp:TemplateField HeaderText="State" SortExpression="State">
                                <EditItemTemplate>
                                    <asp:TextBox ID="txtEditState" runat="server" Columns="2" MaxLength="2" 
                                        style="text-align: right" Text='<%# Bind("State") %>'></asp:TextBox>
                                    <asp:RequiredFieldValidator ID="RequiredFieldValidator1" runat="server" 
                                        ControlToValidate="txtEditState" Display="Dynamic" ErrorMessage="Enter State" 
                                        Font-Size="XX-Small" SetFocusOnError="True" ValidationGroup="Edit">Please enter State</asp:RequiredFieldValidator>
                                </EditItemTemplate>
                                <ItemTemplate>
                                    <asp:Label ID="Label1" runat="server" Text='<%# Bind("State") %>'></asp:Label>
                                </ItemTemplate>
                                <ItemStyle HorizontalAlign="Right" />
                            </asp:TemplateField>
                        </Columns>
                        <FooterStyle BackColor="#F7DFB5" ForeColor="#8C4510" />
                        <PagerStyle ForeColor="#8C4510" HorizontalAlign="Center" />
                        <SelectedRowStyle BackColor="#738A9C" Font-Bold="True" ForeColor="White" />
                        <HeaderStyle BackColor="#A55129" Font-Bold="True" ForeColor="White" />
                        <EditRowStyle HorizontalAlign="Right" />
                    </asp:GridView>
                    </b>
                </td>
            </tr>
           
            <tr>
                <td>
                    &nbsp;</td>
            </tr>
           
        </table>
         </ContentTemplate>
        </asp:UpdatePanel>    
    </div>
    <div id="accordianAJAXcontrol">
        <cc1:Accordion ID="MyAccordion" runat="server"
                            SelectedIndex="0" 
                           HeaderCssClass="accordionHeader" 
                           ContentCssClass="accordionContent" 
                           FadeTransitions="true" 
                           FramesPerSecond="40" 
                           TransitionDuration="250"
                           AutoSize= "None" >
                           <Panes>
                                <cc1:AccordionPane ID="AccordionPane1" runat="server">
            
                                <header>
                                     <a href = "" onclick = "return false;" class = "accordionLink"> Programming Instructions:  Step 1</a>
                                        
                                    </header>
                                    <Content>
                                        Be sure to change the size of the Fields in your DB table to match the max size of the textboxes in the
                                        GridView where you will edit data. For the State field, I want them to only have two characters to put in a State.
                                        So I changed the datatype in the State field to nchar(2) instead of nchar(10) or whatever it was! Also, do not allow nulls
                                        so you can test the requiredfieldvalidator I added.
                             
                                    </Content>
                                </cc1:AccordionPane>
                             <cc1:AccordionPane ID="AccordionPane2" runat="server">
            
                                <header>
                                     <a href = "" onclick = "return false;" class = "accordionLink"> Step 2</a>
                                        
                                    </header>
                                    <Content>
                                        Now choose Edit columns from the Grid's smart tag. Change all your columns to template columns. Now choose
                                        edit templates from the Edit Columns dialog box. Choose the field you want. Let's say "State". In the Edit template you will
                                        see a textbox. First, rename it...like txtEditState in its properties (F4). Then change the Column property to 2 and the maxLength to 2.
                                        This will make the box smaller when you edit and will only allow two characters. Do the same for the other fields. Make sure the
                                        MaxLength = size of the DB field in the DB table.
                             
                                    </Content>
                                </cc1:AccordionPane>
                                  <cc1:AccordionPane ID="AccordionPane3" runat="server">
            
                                <header>
                                     <a href = "" onclick = "return false;" class = "accordionLink"> Step 3</a>
                                        
                                    </header>
                                    <Content>
                                        Now add a RequiredFieldValidator from the toolbox and drag it to the right of your txtEditState textbox. Set the properties
                                        of the control by looking at this screen shot:
                                        <asp:HyperLink ID="HyperLink1" runat="server" ForeColor="White" 
                                        NavigateUrl="~/How to set the following properties for the RequiredFieldValidator Control.htm">Click here</asp:HyperLink>
                                        While you are editing templates, go ahead and add confim delete capability. Choose the column 0 item template and click once
                                        on the delete link. Go to the properties of the delete link and add this code to the onClientClick event:
                                        return confirm("Are you sure you want to delete?"); This will setup a Javascript confirm dialog box.
                                                                     
                                    </Content>
                                </cc1:AccordionPane>
                                <cc1:AccordionPane ID="AccordionPane4" runat="server">
            
                                <header>
                                     <a href = "" onclick = "return false;" class = "accordionLink"> Step 4</a>
                                        
                                    </header>
                                    <Content>
                                        Finally, I want the letters inside the textbox to be right-aligned when they edit the State field. You can do this
                                        in two ways. Go into the Edit templates dialog again. Now, select the textbox we were working on. Choose "Right" from the
                                        formatting toolbar in VS. The other way to do this is to put this attribute code into your html source code after the binding expression for each control:  style="text-align: right">
                             
                                    </Content>
                                </cc1:AccordionPane>
                           </Panes>
                           
            </cc1:Accordion>          
    
    </div>
    </form>
    
    
</body>



</html>
